Index: uspace/app/tester/mm/mapping1.c
===================================================================
--- uspace/app/tester/mm/mapping1.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/tester/mm/mapping1.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -30,5 +30,5 @@
 #include <stdlib.h>
 #include <stddef.h>
-#include <malloc.h>
+#include <str_error.h>
 #include <as.h>
 #include <errno.h>
@@ -75,6 +75,6 @@
 		int rc = as_get_physical_mapping(page_start, NULL);
 		if (rc != expected_rc) {
-			TPRINTF("as_get_physical_mapping() = %d != %d\n",
-			    rc, expected_rc);
+			TPRINTF("as_get_physical_mapping() = %s != %s\n",
+			    str_error_name(rc), str_error_name(expected_rc));
 			return false;
 		}
Index: uspace/app/tester/mm/pager1.c
===================================================================
--- uspace/app/tester/mm/pager1.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/tester/mm/pager1.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -30,5 +30,4 @@
 #include <vfs/vfs.h>
 #include <stdlib.h>
-#include <malloc.h>
 #include <as.h>
 #include <ns.h>
@@ -45,13 +44,17 @@
 static void *create_paged_area(size_t size)
 {
+	size_t nwr;
+	int rc;
+
 	TPRINTF("Creating temporary file...\n");
 
-	fd = vfs_lookup_open(TEST_FILE, WALK_REGULAR | WALK_MAY_CREATE,
-	    MODE_READ | MODE_WRITE);
-	if (fd < 0)
+	rc = vfs_lookup_open(TEST_FILE, WALK_REGULAR | WALK_MAY_CREATE,
+	    MODE_READ | MODE_WRITE, &fd);
+	if (rc != EOK)
 		return NULL;
 	(void) vfs_unlink_path(TEST_FILE);
 
-	if (vfs_write(fd, (aoff64_t []) {0}, text, sizeof(text)) < 0) {
+	rc = vfs_write(fd, (aoff64_t []) {0}, text, sizeof(text), &nwr);
+	if (rc != EOK) {
 		vfs_put(fd);
 		return NULL;
Index: uspace/app/tester/stdio/stdio1.c
===================================================================
--- uspace/app/tester/stdio/stdio1.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/tester/stdio/stdio1.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -30,4 +30,5 @@
 #include <stdlib.h>
 #include <stddef.h>
+#include <str_error.h>
 #include <errno.h>
 #include "../tester.h"
@@ -46,5 +47,5 @@
 	file = fopen(file_name, "rt");
 	if (file == NULL) {
-		TPRINTF("errno = %d\n", errno);
+		TPRINTF("errno = %s\n", str_error_name(errno));
 		return "Failed opening file";
 	} else
@@ -54,5 +55,5 @@
 	size_t cnt = fread(buf, 1, BUF_SIZE, file);
 	if (ferror(file)) {
-		TPRINTF("errno = %d\n", errno);
+		TPRINTF("errno = %s\n", str_error_name(errno));
 		fclose(file);
 		return "Failed reading file";
@@ -65,5 +66,5 @@
 	TPRINTF("Seek to beginning...");
 	if (fseek(file, 0, SEEK_SET) != 0) {
-		TPRINTF("errno = %d\n", errno);
+		TPRINTF("errno = %s\n", str_error_name(errno));
 		fclose(file);
 		return "Failed seeking in file";
@@ -83,5 +84,5 @@
 	TPRINTF("Close...");
 	if (fclose(file) != 0) {
-		TPRINTF("errno = %d\n", errno);
+		TPRINTF("errno = %s\n", str_error_name(errno));
 		return "Failed closing file";
 	} else
Index: uspace/app/tester/stdio/stdio2.c
===================================================================
--- uspace/app/tester/stdio/stdio2.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/tester/stdio/stdio2.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -30,4 +30,5 @@
 #include <stdlib.h>
 #include <stddef.h>
+#include <str_error.h>
 #include <errno.h>
 #include "../tester.h"
@@ -42,5 +43,5 @@
 	file = fopen(file_name, "wt");
 	if (file == NULL) {
-		TPRINTF("errno = %d\n", errno);
+		TPRINTF("errno = %s\n", str_error_name(errno));
 		return "Failed opening file";
 	} else
@@ -53,5 +54,5 @@
 	TPRINTF("Close...");
 	if (fclose(file) != 0) {
-		TPRINTF("errno = %d\n", errno);
+		TPRINTF("errno = %s\n", str_error_name(errno));
 		return "Failed closing file";
 	} else
@@ -61,5 +62,5 @@
 	file = fopen(file_name, "rt");
 	if (file == NULL) {
-		TPRINTF("errno = %d\n", errno);
+		TPRINTF("errno = %s\n", str_error_name(errno));
 		return "Failed opening file";
 	} else
@@ -76,5 +77,5 @@
 	TPRINTF("\nClose...");
 	if (fclose(file) != 0) {
-		TPRINTF("errno = %d\n", errno);
+		TPRINTF("errno = %s\n", str_error_name(errno));
 		return "Failed closing file";
 	} else
Index: uspace/app/tester/tester.c
===================================================================
--- uspace/app/tester/tester.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/tester/tester.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -76,5 +76,5 @@
 #include "mm/pager1.def"
 #include "hw/serial/serial1.def"
-#include "hw/misc/virtchar1.def"
+#include "chardev/chardev1.def"
 	{NULL, NULL, NULL, false}
 };
Index: uspace/app/tester/tester.h
===================================================================
--- uspace/app/tester/tester.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/tester/tester.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -108,7 +108,7 @@
 extern const char *test_pager1(void);
 extern const char *test_serial1(void);
-extern const char *test_virtchar1(void);
 extern const char *test_devman1(void);
 extern const char *test_devman2(void);
+extern const char *test_chardev1(void);
 
 extern test_t tests[];
Index: uspace/app/tester/vfs/vfs1.c
===================================================================
--- uspace/app/tester/vfs/vfs1.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/tester/vfs/vfs1.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -31,4 +31,5 @@
 #include <stdlib.h>
 #include <stddef.h>
+#include <str_error.h>
 #include <str.h>
 #include <vfs/vfs.h>
@@ -72,18 +73,20 @@
 	rc = vfs_link_path(TEST_DIRECTORY, KIND_DIRECTORY, NULL);
 	if (rc != EOK) {
-		TPRINTF("rc=%d\n", rc);
+		TPRINTF("rc=%s\n", str_error_name(rc));
 		return "vfs_link_path() failed";
 	}
 	TPRINTF("Created directory %s\n", TEST_DIRECTORY);
 	
-	int fd0 = vfs_lookup_open(TEST_FILE, WALK_REGULAR | WALK_MAY_CREATE,
-	    MODE_READ | MODE_WRITE);
-	if (fd0 < 0)
+	int fd0;
+	rc = vfs_lookup_open(TEST_FILE, WALK_REGULAR | WALK_MAY_CREATE,
+	    MODE_READ | MODE_WRITE, &fd0);
+	if (rc != EOK)
 		return "vfs_lookup_open() failed";
 	TPRINTF("Created file %s (fd=%d)\n", TEST_FILE, fd0);
 	
 	size_t size = sizeof(text);
-	ssize_t cnt = vfs_write(fd0, &pos, text, size);
-	if (cnt < 0)
+	size_t cnt;
+	rc  = vfs_write(fd0, &pos, text, size, &cnt);
+	if (rc != EOK)
 		return "write() failed";
 	TPRINTF("Written %zd bytes\n", cnt);
@@ -93,15 +96,15 @@
 	char buf[BUF_SIZE];
 	TPRINTF("read..\n");
-	while ((cnt = vfs_read(fd0, &pos, buf, BUF_SIZE))) {
-		TPRINTF("read returns %zd\n", cnt);
-		if (cnt < 0)
+	while ((rc = vfs_read(fd0, &pos, buf, BUF_SIZE, &cnt))) {
+		TPRINTF("read returns rc = %s, cnt = %zu\n", str_error_name(rc), cnt);
+		if (rc != EOK)
 			return "read() failed";
 		
-		int _cnt = (int) cnt;
-		if (_cnt != cnt) {
+		int icnt = (int) cnt;
+		if ((size_t) icnt != cnt) {
 			/* Count overflow, just to be sure. */
 			TPRINTF("Read %zd bytes\n", cnt);
 		} else {
-			TPRINTF("Read %zd bytes: \"%.*s\"\n", cnt, _cnt, buf);
+			TPRINTF("Read %zd bytes: \"%.*s\"\n", cnt, icnt, buf);
 		}
 	}
Index: uspace/app/trace/Makefile
===================================================================
--- uspace/app/trace/Makefile	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/trace/Makefile	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,6 +36,5 @@
 	ipcp.c \
 	ipc_desc.c \
-	proto.c \
-	errors.c
+	proto.c
 
 include $(USPACE_PREFIX)/Makefile.common
Index: uspace/app/trace/ipcp.c
===================================================================
--- uspace/app/trace/ipcp.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/trace/ipcp.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -35,4 +35,5 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include <str_error.h>
 #include <inttypes.h>
 #include <adt/hash_table.h>
@@ -44,6 +45,4 @@
 #include "ipcp.h"
 
-#define IPCP_CALLID_SYNC 0
-
 typedef struct {
 	sysarg_t phone_hash;
@@ -145,5 +144,5 @@
 		V_INTEGER,
 		V_INTEGER,
-		V_INTEGER		
+		V_INTEGER
 	};
 
@@ -189,6 +188,6 @@
 
 	if ((display_mask & DM_IPC) != 0) {
-		printf("Call ID: %p, phone: %d, proto: %s, method: ",
-		    (void *) hash, phone,
+		printf("Call ID: %d, phone: %d, proto: %s, method: ",
+		    hash, phone,
 		    (proto ? proto->name : "n/a"));
 		ipc_m_print(proto, IPC_GET_IMETHOD(*call));
@@ -266,7 +265,7 @@
 	
 	if ((display_mask & DM_IPC) != 0) {
-		printf("Response to %p: retval=%" PRIdn ", args = (%" PRIun ", "
+		printf("Response to %d: retval=%" PRIdn ", args = (%" PRIun ", "
 		    "%" PRIun ", %" PRIun ", %" PRIun ", %" PRIun ")\n",
-		    (void *) hash, retval, IPC_GET_ARG1(*answer),
+		    hash, retval, IPC_GET_ARG1(*answer),
 		    IPC_GET_ARG2(*answer), IPC_GET_ARG3(*answer),
 		    IPC_GET_ARG4(*answer), IPC_GET_ARG5(*answer));
@@ -323,13 +322,11 @@
 	pending_call_t *pcall;
 	
-	if ((hash & IPC_CALLID_ANSWERED) == 0 && hash != IPCP_CALLID_SYNC) {
+	if ((call->flags & IPC_CALL_ANSWERED) == 0) {
 		/* Not a response */
 		if ((display_mask & DM_IPC) != 0) {
-			printf("Not a response (hash %p)\n", (void *) hash);
+			printf("Not a response (hash %d)\n", hash);
 		}
 		return;
 	}
-	
-	hash = hash & ~IPC_CALLID_ANSWERED;
 	
 	item = hash_table_find(&pending_calls, &hash);
@@ -348,14 +345,8 @@
 }
 
-void ipcp_call_sync(int phone, ipc_call_t *call, ipc_call_t *answer)
-{
-	ipcp_call_out(phone, call, IPCP_CALLID_SYNC);
-	ipcp_call_in(answer, IPCP_CALLID_SYNC);
-}
-
 void ipcp_hangup(int phone, int rc)
 {
 	if ((display_mask & DM_SYSTEM) != 0) {
-		printf("Hang phone %d up -> %d\n", phone, rc);
+		printf("Hang phone %d up -> %s\n", phone, str_error_name(rc));
 		ipcp_connection_clear(phone);
 	}
Index: uspace/app/trace/syscalls.c
===================================================================
--- uspace/app/trace/syscalls.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/trace/syscalls.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -54,5 +54,5 @@
 
     [SYS_IPC_CALL_ASYNC_FAST] = { "ipc_call_async_fast", 6,	V_HASH },
-    [SYS_IPC_CALL_ASYNC_SLOW] = { "ipc_call_async_slow", 2,	V_HASH },
+    [SYS_IPC_CALL_ASYNC_SLOW] = { "ipc_call_async_slow", 3,	V_HASH },
 
     [SYS_IPC_ANSWER_FAST] = { "ipc_answer_fast",	6,	V_ERRNO },
Index: uspace/app/trace/trace.c
===================================================================
--- uspace/app/trace/trace.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/trace/trace.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -38,4 +38,5 @@
 #include <stdint.h>
 #include <stddef.h>
+#include <str_error.h>
 #include <inttypes.h>
 #include <fibril.h>
@@ -62,5 +63,4 @@
 #include "syscalls.h"
 #include "ipcp.h"
-#include "errors.h"
 #include "trace.h"
 
@@ -157,5 +157,5 @@
 		
 		printf("Error connecting\n");
-		printf("ipc_connect_task(%" PRIu64 ") -> %d ", task_id, errno);
+		printf("ipc_connect_task(%" PRIu64 ") -> %s ", task_id, str_error_name(errno));
 		return errno;
 	}
@@ -163,5 +163,5 @@
 	int rc = udebug_begin(ksess);
 	if (rc < 0) {
-		printf("udebug_begin() -> %d\n", rc);
+		printf("udebug_begin() -> %s\n", str_error_name(rc));
 		return rc;
 	}
@@ -169,5 +169,5 @@
 	rc = udebug_set_evmask(ksess, UDEBUG_EM_ALL);
 	if (rc < 0) {
-		printf("udebug_set_evmask(0x%x) -> %d\n ", UDEBUG_EM_ALL, rc);
+		printf("udebug_set_evmask(0x%x) -> %s\n ", UDEBUG_EM_ALL, str_error_name(rc));
 		return rc;
 	}
@@ -187,5 +187,5 @@
 		THBUF_SIZE*sizeof(unsigned), &tb_copied, &tb_needed);
 	if (rc < 0) {
-		printf("udebug_thread_read() -> %d\n", rc);
+		printf("udebug_thread_read() -> %s\n", str_error_name(rc));
 		return rc;
 	}
@@ -225,6 +225,6 @@
 		if (sval >= -15 && sval <= 0) {
 			printf("%ld %s (%s)", sval,
-			    err_desc[-sval].name,
-			    err_desc[-sval].desc);
+			    str_error_name((int) sval),
+			    str_error((int) sval));
 		} else {
 			printf("%ld", sval);
@@ -234,6 +234,6 @@
 		if (sval >= -15 && sval < 0) {
 			printf("%ld %s (%s)", sval,
-			    err_desc[-sval].name,
-			    err_desc[-sval].desc);
+			    str_error_name((int) sval),
+			    str_error((int) sval));
 		} else {
 			printf("%ld", sval);
@@ -284,5 +284,5 @@
 	sysarg_t phoneid;
 	
-	if (sc_rc == (sysarg_t) IPC_CALLRET_FATAL)
+	if (sc_rc != (sysarg_t) EOK)
 		return;
 
@@ -304,5 +304,5 @@
 	int rc;
 
-	if (sc_rc == (sysarg_t) IPC_CALLRET_FATAL)
+	if (sc_rc != (sysarg_t) EOK)
 		return;
 
@@ -604,5 +604,5 @@
 	rc = get_thread_list();
 	if (rc < 0) {
-		printf("Failed to get thread list (error %d)\n", rc);
+		printf("Failed to get thread list (%s)\n", str_error(rc));
 		return;
 	}
@@ -643,5 +643,5 @@
 			rc = udebug_stop(sess, thash);
 			if (rc != EOK)
-				printf("Error: stop -> %d\n", rc);
+				printf("Error: stop -> %s\n", str_error_name(rc));
 			break;
 		case KC_R:
Index: uspace/app/vcalc/vcalc.c
===================================================================
--- uspace/app/vcalc/vcalc.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/vcalc/vcalc.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -38,5 +38,5 @@
 #include <stdbool.h>
 #include <stdio.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <io/pixel.h>
 #include <task.h>
Index: uspace/app/vdemo/vdemo.c
===================================================================
--- uspace/app/vdemo/vdemo.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/vdemo/vdemo.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -35,5 +35,5 @@
 #include <stdbool.h>
 #include <stdio.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <io/pixel.h>
 #include <task.h>
Index: uspace/app/viewer/viewer.c
===================================================================
--- uspace/app/viewer/viewer.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/viewer/viewer.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -37,5 +37,5 @@
 #include <vfs/vfs.h>
 #include <errno.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <stdbool.h>
 #include <window.h>
@@ -109,10 +109,11 @@
 static bool img_load(const char *fname, surface_t **p_local_surface)
 {
-	int fd = vfs_lookup_open(fname, WALK_REGULAR, MODE_READ);
-	if (fd < 0)
+	int fd;
+	int rc = vfs_lookup_open(fname, WALK_REGULAR, MODE_READ, &fd);
+	if (rc != EOK)
 		return false;
 	
 	struct stat stat;
-	int rc = vfs_stat(fd, &stat);
+	rc = vfs_stat(fd, &stat);
 	if (rc != EOK) {
 		vfs_put(fd);
@@ -126,6 +127,7 @@
 	}
 
-	ssize_t rd = vfs_read(fd, (aoff64_t []) {0}, tga, stat.size);
-	if ((rd < 0) || (rd != (ssize_t) stat.size)) {
+	size_t nread;
+	rc = vfs_read(fd, (aoff64_t []) {0}, tga, stat.size, &nread);
+	if (rc != EOK || nread != stat.size) {
 		free(tga);
 		vfs_put(fd);
Index: uspace/app/vlaunch/vlaunch.c
===================================================================
--- uspace/app/vlaunch/vlaunch.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/vlaunch/vlaunch.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,5 +36,5 @@
 #include <errno.h>
 #include <stdio.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <task.h>
 #include <str_error.h>
Index: uspace/app/wavplay/dplay.c
===================================================================
--- uspace/app/wavplay/dplay.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/wavplay/dplay.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -345,5 +345,7 @@
 	}
 	printf("Playing on device: %s.\n", device);
-	if (audio_pcm_query_cap(session, AUDIO_CAP_PLAYBACK) <= 0) {
+	sysarg_t val;
+	ret = audio_pcm_query_cap(session, AUDIO_CAP_PLAYBACK, &val);
+	if (ret != EOK || !val) {
 		printf("Device %s does not support playback\n", device);
 		ret = ENOTSUP;
@@ -386,8 +388,10 @@
 		goto cleanup;
 	}
-	if (audio_pcm_query_cap(pb.device, AUDIO_CAP_BUFFER_POS) > 0) {
+	ret = audio_pcm_query_cap(pb.device, AUDIO_CAP_BUFFER_POS, &val);
+	if (ret == EOK && val) {
 		play(&pb);
 	} else {
-		if (audio_pcm_query_cap(pb.device, AUDIO_CAP_INTERRUPT) > 0)
+		ret = audio_pcm_query_cap(pb.device, AUDIO_CAP_INTERRUPT, &val);
+		if (ret == EOK && val)
 			play_fragment(&pb);
 		else
Index: uspace/app/wavplay/drec.c
===================================================================
--- uspace/app/wavplay/drec.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/wavplay/drec.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -176,4 +176,5 @@
 	int ret = EOK;
 	audio_pcm_sess_t *session = NULL;
+	sysarg_t val;
 	if (str_cmp(device, "default") == 0) {
 		session = audio_pcm_open_default();
@@ -186,5 +187,6 @@
 	}
 	printf("Recording on device: %s.\n", device);
-	if (audio_pcm_query_cap(session, AUDIO_CAP_CAPTURE) <= 0) {
+	ret = audio_pcm_query_cap(session, AUDIO_CAP_CAPTURE, &val);
+	if (ret != EOK || !val) {
 		printf("Device %s does not support recording\n", device);
 		ret = ENOTSUP;
@@ -225,5 +227,6 @@
 		goto cleanup;
 	}
-	if (audio_pcm_query_cap(rec.device, AUDIO_CAP_INTERRUPT) > 0)
+	ret = audio_pcm_query_cap(rec.device, AUDIO_CAP_INTERRUPT, &val);
+	if (ret == EOK && val)
 		record_fragment(&rec, format);
 	else
Index: uspace/app/wavplay/main.c
===================================================================
--- uspace/app/wavplay/main.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/wavplay/main.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -37,5 +37,5 @@
 #include <errno.h>
 #include <fibril_synch.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <str_error.h>
 #include <stdio.h>
Index: uspace/app/websrv/websrv.c
===================================================================
--- uspace/app/websrv/websrv.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/websrv/websrv.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -168,5 +168,5 @@
 		rc = tcp_conn_recv_wait(recv->conn, recv->rbuf, BUFFER_SIZE, &nrecv);
 		if (rc != EOK) {
-			fprintf(stderr, "tcp_conn_recv() failed (%d)\n", rc);
+			fprintf(stderr, "tcp_conn_recv() failed: %s\n", str_error(rc));
 			return rc;
 		}
@@ -247,4 +247,5 @@
 	char *fname = NULL;
 	int rc;
+	size_t nr;
 	int fd = -1;
 	
@@ -264,6 +265,6 @@
 	}
 	
-	fd = vfs_lookup_open(fname, WALK_REGULAR, MODE_READ);
-	if (fd < 0) {
+	rc = vfs_lookup_open(fname, WALK_REGULAR, MODE_READ, &fd);
+	if (rc != EOK) {
 		rc = send_response(conn, msg_not_found);
 		goto out;
@@ -279,12 +280,10 @@
 	aoff64_t pos = 0;
 	while (true) {
-		ssize_t nr = vfs_read(fd, &pos, fbuf, BUFFER_SIZE);
+		rc = vfs_read(fd, &pos, fbuf, BUFFER_SIZE, &nr);
+		if (rc != EOK)
+			goto out;
+		
 		if (nr == 0)
 			break;
-		
-		if (nr < 0) {
-			rc = EIO;
-			goto out;
-		}
 		
 		rc = tcp_conn_send(conn, fbuf, nr);
Index: uspace/app/wifi_supplicant/wifi_supplicant.c
===================================================================
--- uspace/app/wifi_supplicant/wifi_supplicant.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/app/wifi_supplicant/wifi_supplicant.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -40,4 +40,6 @@
 #include <errno.h>
 #include <stdio.h>
+#include <stdlib.h>
+#include <str_error.h>
 #include <loc.h>
 
@@ -138,5 +140,5 @@
 	int rc = get_wifi_list(&wifis, &count);
 	if (rc != EOK) {
-		printf("Error fetching wifi list.\n");
+		printf("Error fetching wifi list: %s\n", str_error(rc));
 		return EINVAL;
 	}
@@ -147,5 +149,5 @@
 		rc = loc_service_get_name(wifis[i], &svc_name);
 		if (rc != EOK) {
-			printf("Error getting service name.\n");
+			printf("Error getting service name: %s\n", str_error(rc));
 			free(wifis);
 			return rc;
@@ -176,6 +178,6 @@
 			printf("Device is not ready yet.\n");
 		else
-			printf("Error when disconnecting device. "
-			    "Error: %d\n", rc);
+			printf("Error when disconnecting device: %s\n",
+			    str_error(rc));
 		
 		return rc;
@@ -191,6 +193,6 @@
 			printf("Given SSID not in scan results.\n");
 		else
-			printf("Error when connecting to network. "
-			    "Error: %d\n", rc);
+			printf("Error when connecting to network: %s\n",
+			    str_error(rc));
 		
 		return rc;
@@ -220,6 +222,6 @@
 			printf("Not connected to any WiFi network.\n");
 		else
-			printf("Error when disconnecting from network. "
-			    "Error: %d\n", rc);
+			printf("Error when disconnecting from network: %s\n",
+			    str_error(rc));
 		
 		return rc;
@@ -246,5 +248,6 @@
 			printf("Device is not ready yet.\n");
 		else
-			printf("Failed to fetch scan results. Error: %d\n", rc);
+			printf("Failed to fetch scan results: %s\n",
+			    str_error(rc));
 		
 		return rc;
@@ -276,6 +279,6 @@
 	int rc = inetcfg_init();
 	if (rc != EOK) {
-		printf("%s: Failed connecting to inetcfg service (%d).\n",
-		    NAME, rc);
+		printf("%s: Failed connecting to inetcfg service: %s.\n",
+		    NAME, str_error(rc));
 		return 1;
 	}
@@ -283,6 +286,6 @@
 	rc = dhcp_init();
 	if (rc != EOK) {
-		printf("%s: Failed connecting to dhcp service (%d).\n",
-		    NAME, rc);
+		printf("%s: Failed connecting to dhcp service: %s.\n",
+		    NAME, str_error(rc));
 		return 1;
 	}
Index: uspace/doc/main_page.h
===================================================================
--- uspace/doc/main_page.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
+++ uspace/doc/main_page.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -0,0 +1,12 @@
+/**
+ @mainpage HelenOS Operating System Source Code Reference
+
+HelenOS is a portable microkernel-based multiserver operating system designed and implemented from scratch. It decomposes key operating system functionality such as file systems, networking, device drivers and graphical user interface into a collection of fine-grained user space components that interact with each other via message passing. A failure or crash of one component does not directly harm others. HelenOS is therefore flexible, modular, extensible, fault tolerant and easy to understand.
+
+HelenOS does not aim to be a clone of any existing operating system and trades compatibility with legacy APIs for cleaner design. Most of HelenOS components have been made to order specifically for HelenOS so that its essential parts can stay free of adaptation layers, glue code, franken-components and the maintenance burden incurred by them.
+
+HelenOS runs on seven different processor architectures and machines ranging from embedded ARM devices and single-board computers through multicore 32-bit and 64-bit desktop PCs to 64-bit Itanium and SPARC rack-mount servers.
+
+HelenOS is open source, free software. Its source code is available under the BSD license. Some third-party components are licensed under GPL. 
+
+*/
Index: uspace/drv/audio/hdaudio/codec.c
===================================================================
--- uspace/drv/audio/hdaudio/codec.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/drv/audio/hdaudio/codec.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -37,4 +37,5 @@
 #include <ddf/log.h>
 #include <errno.h>
+#include <str_error.h>
 #include <stdlib.h>
 
@@ -514,5 +515,5 @@
 		goto error;
 
-	ddf_msg(LVL_NOTE, "hda_get_subnc -> %d", rc);
+	ddf_msg(LVL_NOTE, "hda_get_subnc -> %s", str_error_name(rc));
 	ddf_msg(LVL_NOTE, "sfg=%d nfg=%d", sfg, nfg);
 
@@ -524,5 +525,5 @@
 			goto error;
 
-		ddf_msg(LVL_NOTE, "hda_get_fgrp_type -> %d", rc);
+		ddf_msg(LVL_NOTE, "hda_get_fgrp_type -> %s", str_error_name(rc));
 		ddf_msg(LVL_NOTE, "unsol: %d, grptype: %d", unsol, grptype);
 
@@ -546,5 +547,5 @@
 			goto error;
 
-		ddf_msg(LVL_NOTE, "hda_get_subnc -> %d", rc);
+		ddf_msg(LVL_NOTE, "hda_get_subnc -> %s", str_error_name(rc));
 		ddf_msg(LVL_NOTE, "saw=%d baw=%d", saw, naw);
 
Index: uspace/drv/audio/hdaudio/hdaudio.c
===================================================================
--- uspace/drv/audio/hdaudio/hdaudio.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/drv/audio/hdaudio/hdaudio.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -58,5 +58,5 @@
 static int hda_fun_offline(ddf_fun_t *fun);
 
-static void hdaudio_interrupt(ipc_callid_t, ipc_call_t *, ddf_dev_t *);
+static void hdaudio_interrupt(ipc_call_t *, ddf_dev_t *);
 
 static driver_ops_t driver_ops = {
@@ -259,14 +259,14 @@
 	rc = hw_res_enable_interrupt(hda->parent_sess, res.irqs.irqs[0]);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed enabling interrupt. (%d)", rc);
-		goto error;
-	}
-
-	int irq_cap = register_interrupt_handler(dev, res.irqs.irqs[0],
-	    hdaudio_interrupt, &irq_code);
-	if (irq_cap < 0) {
-		rc = irq_cap;
-		ddf_msg(LVL_ERROR, "Failed registering interrupt handler. (%d)",
-		    rc);
+		ddf_msg(LVL_ERROR, "Failed enabling interrupt.: %s", str_error(rc));
+		goto error;
+	}
+
+	int irq_cap;
+	rc = register_interrupt_handler(dev, res.irqs.irqs[0],
+	    hdaudio_interrupt, &irq_code, &irq_cap);
+	if (rc != EOK) {
+		ddf_msg(LVL_ERROR, "Failed registering interrupt handler: %s",
+		    str_error_name(rc));
 		goto error;
 	}
@@ -314,5 +314,5 @@
 	hw_res_list_parsed_clean(&res);
 
-	ddf_msg(LVL_NOTE, "Failing hda_dev_add() -> %d", rc);
+	ddf_msg(LVL_NOTE, "Failing hda_dev_add() -> %s", str_error_name(rc));
 	return rc;
 }
@@ -368,6 +368,5 @@
 }
 
-static void hdaudio_interrupt(ipc_callid_t iid, ipc_call_t *icall,
-    ddf_dev_t *dev)
+static void hdaudio_interrupt(ipc_call_t *icall, ddf_dev_t *dev)
 {
 	hda_t *hda = (hda_t *)ddf_dev_data_get(dev);
Index: uspace/drv/audio/hdaudio/stream.c
===================================================================
--- uspace/drv/audio/hdaudio/stream.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/drv/audio/hdaudio/stream.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -39,4 +39,5 @@
 #include <ddi.h>
 #include <errno.h>
+#include <str_error.h>
 #include <macros.h>
 #include <stdlib.h>
@@ -122,5 +123,5 @@
 	    0, &buffer_phys, &buffer);
 	if (rc != EOK) {
-		ddf_msg(LVL_NOTE, "dmamem_map_anon -> %d", rc);
+		ddf_msg(LVL_NOTE, "dmamem_map_anon -> %s", str_error_name(rc));
 		goto error;
 	}
Index: uspace/drv/audio/sb16/dsp.c
===================================================================
--- uspace/drv/audio/sb16/dsp.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/drv/audio/sb16/dsp.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -303,10 +303,10 @@
 
 	// TODO: Assumes DMA 16
-	const int remain = hw_res_dma_channel_remain(sess, dsp->dma16_channel);
-	if (remain >= 0) {
+	size_t remain;
+	int rc = hw_res_dma_channel_remain(sess, dsp->dma16_channel, &remain);
+	if (rc == EOK) {
 		*pos = dsp->buffer.size - remain;
-		return EOK;
-	}
-	return remain;
+	}
+	return rc;
 }
 
Index: uspace/drv/audio/sb16/main.c
===================================================================
--- uspace/drv/audio/sb16/main.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/drv/audio/sb16/main.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -76,5 +76,5 @@
 }
 
-static void irq_handler(ipc_callid_t iid, ipc_call_t *call, ddf_dev_t *dev)
+static void irq_handler(ipc_call_t *call, ddf_dev_t *dev)
 {
 	sb16_t *sb16_dev = ddf_dev_data_get(dev);
@@ -123,8 +123,7 @@
 	};
 
-	irq_cap = register_interrupt_handler(device, irq, irq_handler,
-	    &irq_code);
-	if (irq_cap < 0) {
-		rc = irq_cap;
+	rc = register_interrupt_handler(device, irq, irq_handler,
+	    &irq_code, &irq_cap);
+	if (rc != EOK) {
 		ddf_log_error("Failed to register irq handler: %s.",
 		    str_error(rc));
Index: uspace/drv/block/ahci/ahci.c
===================================================================
--- uspace/drv/block/ahci/ahci.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/drv/block/ahci/ahci.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -890,10 +890,9 @@
 /** AHCI interrupt handler.
  *
- * @param iid   The IPC call id.
  * @param icall The IPC call structure.
  * @param dev   DDF device structure.
  *
  */
-static void ahci_interrupt(ipc_callid_t iid, ipc_call_t *icall, ddf_dev_t *dev)
+static void ahci_interrupt(ipc_call_t *icall, ddf_dev_t *dev)
 {
 	ahci_dev_t *ahci = dev_ahci_dev(dev);
@@ -1185,12 +1184,13 @@
 	ct.ranges = ahci_ranges;
 	
-	int irq_cap = register_interrupt_handler(dev,
-	    hw_res_parsed.irqs.irqs[0], ahci_interrupt, &ct);
-	if (irq_cap < 0) {
+	int irq_cap;
+	int rc = register_interrupt_handler(dev,
+	    hw_res_parsed.irqs.irqs[0], ahci_interrupt, &ct, &irq_cap);
+	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed registering interrupt handler.");
 		goto error_register_interrupt_handler;
 	}
 	
-	int rc = hw_res_enable_interrupt(ahci->parent_sess,
+	rc = hw_res_enable_interrupt(ahci->parent_sess,
 	    hw_res_parsed.irqs.irqs[0]);
 	if (rc != EOK) {
Index: uspace/drv/block/ddisk/ddisk.c
===================================================================
--- uspace/drv/block/ddisk/ddisk.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/drv/block/ddisk/ddisk.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -64,5 +64,5 @@
 static void ddisk_bd_connection(ipc_callid_t, ipc_call_t *, void *);
 
-static void ddisk_irq_handler(ipc_callid_t, ipc_call_t *, ddf_dev_t *);
+static void ddisk_irq_handler(ipc_call_t *, ddf_dev_t *);
 
 static driver_ops_t driver_ops = {
@@ -176,5 +176,5 @@
 };
 
-void ddisk_irq_handler(ipc_callid_t iid, ipc_call_t *icall, ddf_dev_t *dev)
+void ddisk_irq_handler(ipc_call_t *icall, ddf_dev_t *dev)
 {
 	ddf_msg(LVL_DEBUG, "ddisk_irq_handler(), status=%" PRIx32,
@@ -503,8 +503,7 @@
 	ddisk_irq_commands[0].addr = (void *) &res_phys->status;
 	ddisk_irq_commands[3].addr = (void *) &res_phys->command;
-	ddisk->irq_cap = register_interrupt_handler(dev, ddisk->ddisk_res.irq,
-	    ddisk_irq_handler, &ddisk_irq_code);
-	if (ddisk->irq_cap < 0) {
-		rc = ddisk->irq_cap;
+	rc = register_interrupt_handler(dev, ddisk->ddisk_res.irq,
+	    ddisk_irq_handler, &ddisk_irq_code, &ddisk->irq_cap);
+	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed to register interrupt handler.");
 		goto error;
Index: uspace/drv/bus/adb/cuda_adb/cuda_adb.c
===================================================================
--- uspace/drv/bus/adb/cuda_adb/cuda_adb.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/drv/bus/adb/cuda_adb/cuda_adb.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -57,5 +57,5 @@
 static void cuda_dev_connection(ipc_callid_t, ipc_call_t *, void *);
 static int cuda_init(cuda_t *);
-static void cuda_irq_handler(ipc_callid_t, ipc_call_t *, void *);
+static void cuda_irq_handler(ipc_call_t *, void *);
 
 static void cuda_irq_listen(cuda_t *);
@@ -252,5 +252,5 @@
 	cuda_irq_code.cmds[0].addr = (void *) &((cuda_regs_t *)
 	    cuda->phys_base)->ifr;
-	async_irq_subscribe(10, cuda_irq_handler, cuda, &cuda_irq_code);
+	async_irq_subscribe(10, cuda_irq_handler, cuda, &cuda_irq_code, NULL);
 
 	/* Enable SR interrupt. */
@@ -264,5 +264,5 @@
 }
 
-static void cuda_irq_handler(ipc_callid_t iid, ipc_call_t *call, void *arg)
+static void cuda_irq_handler(ipc_call_t *call, void *arg)
 {
 	uint8_t rbuf[CUDA_RCV_BUF_SIZE];
